<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Konfigurasi extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
		$this->load->model('Model_konfigurasi','Konfigurasi');
	}

	public function index()
	{
		$this->load->helper('url');
		$this->load->view('Konfigurasi');
	}

	public function ajax_list()
	{
		$this->load->helper('url');

		$list = $this->Konfigurasi->get_datatables();
		$data = array();
		$no = $_POST['start'];
		foreach ($list as $person) {
			$no++;
			$row = array();
			$row[] = $person->nama_satker;
			$row[] = $person->nama_ketua;
			$row[] = $person->nama_wakil_ketua;
			$row[] = $person->nama_panitera;
			$row[] = $person->nama_sekretaris;
			
			
			if($person->logo)
				$row[] = '<a href="'.base_url('upload/logo'.$person->logo).'" target="_blank"><img width="80px" height="100px" src="'.base_url('upload/logo/'.$person->logo).'" class="img-responsive" /></a>';
			else
				$row[] = '(No photo)';

			//add html for action
			$row[] = '<a class="btn btn-icon btn-sm icon-left btn-primary" href="javascript:void(0)" title="Edit" onclick="edit_person('."'".$person->id."'".')"><i class="far fa-edit"></i> Edit</a>';
		
			$data[] = $row;
		}

		$output = array(
						"draw" => $_POST['draw'],
						"recordsTotal" => $this->Konfigurasi->count_all(),
						"recordsFiltered" => $this->Konfigurasi->count_filtered(),
						"data" => $data,
				);
		//output to json format
		echo json_encode($output);
	}

	public function ajax_edit($id)
	{
		$data = $this->Konfigurasi->get_by_id($id);
		// $data->dob = ($data->dob == '0000-00-00') ? '' : $data->dob; // if 0000-00-00 set tu empty for datepicker compatibility
		echo json_encode($data);
	}

	public function ajax_add()
	{
		$this->_validate();
		$hakcuti=12;
		$data = array(
				'nama_satker' => $this->input->post('nama_satker'),
				'nama_ketua' => $this->input->post('nama_ketua'),
				'no_telp_ketua' => $this->input->post('no_telp_ketua'),
				'nama_wakil_ketua' => $this->input->post('nama_wakil_ketua'),
				'no_telp_waka' => $this->input->post('no_telp_waka'),	
				'nama_panitera' => $this->input->post('nama_panitera'),
				'no_telp_panitera' => $this->input->post('no_telp_panitera'),
				'nama_sekretaris' => $this->input->post('nama_sekretaris'),
				'no_telp_sekretaris' => $this->input->post('no_telp_sekretaris'),										
				'alamat' => $this->input->post('alamat'),
				'email' => $this->input->post('email'),

			);

		if(!empty($_FILES['photo']['name']))
		{
			$upload = $this->_do_upload();
			$data['logo'] = $upload;
		}

		$insert = $this->Konfigurasi->save($data);

		echo json_encode(array("status" => TRUE));
	}

	public function ajax_update()
	{
		$this->_validate();
		$data = array(
				'nama_satker' => $this->input->post('nama_satker'),
				'nama_ketua' => $this->input->post('nama_ketua'),
				'no_telp_ketua' => $this->input->post('no_telp_ketua'),
				'nama_wakil_ketua' => $this->input->post('nama_wakil_ketua'),
				'no_telp_waka' => $this->input->post('no_telp_waka'),	
				'nama_panitera' => $this->input->post('nama_panitera'),
				'no_telp_panitera' => $this->input->post('no_telp_panitera'),
				'nama_sekretaris' => $this->input->post('nama_sekretaris'),
				'no_telp_sekretaris' => $this->input->post('no_telp_sekretaris'),										
				'alamat' => $this->input->post('alamat'),
				'email' => $this->input->post('email'),
			);

		if($this->input->post('remove_photo')) // if remove photo checked
		{
			if(file_exists('upload/logo/'.$this->input->post('remove_photo')) && $this->input->post('remove_photo'))
				unlink('upload/logo/'.$this->input->post('remove_photo'));
			$data['logo'] = '';
		}

		if(!empty($_FILES['photo']['name']))
		{
			$upload = $this->_do_upload();
			
			//delete file
			$person = $this->Konfigurasi->get_by_id($this->input->post('id'));
			if(file_exists('upload/logo/'.$person->logo) && $person->logo)
				unlink('upload/logo/'.$person->logo);

			$data['logo'] = $upload;
		}

		$this->Konfigurasi->update(array('id' => $this->input->post('id')), $data);
		echo json_encode(array("status" => TRUE));
	}

	public function ajax_delete($id)
	{
		//delete file
		$person = $this->Konfigurasi->get_by_id($id);
		if(file_exists('upload/logo/'.$person->logo) && $person->logo)
			unlink('upload/logo/'.$person->logo);
		
		$this->Konfigurasi->delete_by_id($id);
		echo json_encode(array("status" => TRUE));
	}

	private function _do_upload()
	{
		$config['upload_path']          = 'upload/logo/';
        $config['allowed_types']        = 'gif|jpg|png|PNG';
        $config['max_size']             = 1000; //set max size allowed in Kilobyte
        $config['max_width']            = 1000; // set max width image allowed
        $config['max_height']           = 1000; // set max height allowed
        $config['file_name']            = round(microtime(true) * 1000); //just milisecond timestamp fot unique name

        $this->load->library('upload', $config);

        if(!$this->upload->do_upload('photo')) //upload and validate
        {
            $data['inputerror'][] = 'photo';
			$data['error_string'][] = 'Upload error: '.$this->upload->display_errors('',''); //show ajax error
			$data['status'] = FALSE;
			echo json_encode($data);
			exit();
		}
		return $this->upload->data('file_name');
	}

	private function _validate()
	{
		$data = array();
		$data['error_string'] = array();
		$data['inputerror'] = array();
		$data['status'] = TRUE;

		if($this->input->post('nama_satker') == '')
		{
			$data['inputerror'][] = 'nama_satker';
			$data['error_string'][] = 'Nama PA is required';
			$data['status'] = FALSE;
		}

		if($this->input->post('nama_ketua') == '')
		{
			$data['inputerror'][] = 'nama_ketua';
			$data['error_string'][] = 'Nama Ketua is required';
			$data['status'] = FALSE;
		}

		if($this->input->post('no_telp_ketua') == '')
		{
			$data['inputerror'][] = 'no_telp_ketua';
			$data['error_string'][] = 'NIP Ketua is required';
			$data['status'] = FALSE;
		}

		if($this->input->post('nama_wakil_ketua') == '')
		{
			$data['inputerror'][] = 'nama_wakil_ketua';
			$data['error_string'][] = 'Nama Wakil Ketua is required';
			$data['status'] = FALSE;
		}

		if($this->input->post('no_telp_waka') == '')
		{
			$data['inputerror'][] = 'no_telp_waka';
			$data['error_string'][] = 'NIP Wakil Ketua is required';
			$data['status'] = FALSE;
		}

		if($this->input->post('nama_panitera') == '')
		{
			$data['inputerror'][] = 'nama_panitera';
			$data['error_string'][] = 'Nama Panitera is required';
			$data['status'] = FALSE;
		}

		if($this->input->post('no_telp_panitera') == '')
		{
			$data['inputerror'][] = 'no_telp_panitera';
			$data['error_string'][] = 'NIP Sekretaris is required';
			$data['status'] = FALSE;
		}

		if($this->input->post('nama_sekretaris') == '')
		{
			$data['inputerror'][] = 'nama_sekretaris';
			$data['error_string'][] = 'Nama Panitera is required';
			$data['status'] = FALSE;
		}

		if($this->input->post('no_telp_sekretaris') == '')
		{
			$data['inputerror'][] = 'no_telp_sekretaris';
			$data['error_string'][] = 'NIP Sekretaris is required';
			$data['status'] = FALSE;
		}

		if($this->input->post('alamat') == '')
		{
			$data['inputerror'][] = 'alamat';
			$data['error_string'][] = 'Alamat is required';
			$data['status'] = FALSE;
		}

		if($this->input->post('email') == '')
		{
			$data['inputerror'][] = 'email';
			$data['error_string'][] = 'Email is required';
			$data['status'] = FALSE;
		}

		// if($this->input->post('notelp') == '')
		// {
		// 	$data['inputerror'][] = 'notelp';
		// 	$data['error_string'][] = 'Telepon is required';
		// 	$data['status'] = FALSE;
		// }

		// if($this->input->post('unit_kerja') == '')
		// {
		// 	$data['inputerror'][] = 'unit_kerja';
		// 	$data['error_string'][] = 'Unit Kerja is required';
		// 	$data['status'] = FALSE;
		// }

		if($data['status'] === FALSE)
		{
			echo json_encode($data);
			exit();
		}
	}

}
