<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Masuk extends CI_Controller {

    public function __construct()
    {
        parent::__construct();
        $this->load->model('Auth_model');
        $this->load->library('form_validation');
        $this->load->library('session');
    }

    public function index()
    {
        $this->load->view('login');
    }

	public function login()
	{
		$this->load->view('login');
    }
    
    public function register()
    {
        $this->load->view('Masuk/register');
    }

    public function proses_login()
    {
        $this->load->library('form_validation');
        $this->load->library('session');

        $this->form_validation->set_rules('username', 'Username', 'required');
        $this->form_validation->set_rules('password', 'Password', 'required');
        
        if ($this->form_validation->run() == FALSE) {
            $errors = $this->form_validation->error_array();
            $this->session->set_flashdata('errors', $errors);
            $this->session->set_flashdata('input', $this->input->post());
            redirect('');
        
        } else {

            $username   = htmlspecialchars($this->input->post('username'));
            $pass       = htmlspecialchars($this->input->post('password'));

            // CEK KE DATABASE BERDASARKAN EMAIL
            $cek_login  = $this->Auth_model->cek_login($username); 
                
            if($cek_login == FALSE)
            {
                echo '<script>alert("Username yang Anda masukan salah.");window.location.href="'.base_url('').'";</script>';
            
            } else {
            
                if(password_verify($pass, $cek_login->password)){
                    // if the username and password is a match
                    // $this->session->set_userdata('id', $cek_login->id);
                    // $this->session->set_userdata('username', $cek_login->username);
                    // $this->session->set_userdata('name', $cek_login->name);
                    $data           = array (
                        'id'        => $cek_login->id,
                        'username'  => $cek_login->username,
                        'name'      => $cek_login->name,
                        'valid'     => true
                    );
                    $this->session->set_userdata($data);
                    redirect('Dashboard');
                        
                } else {
                    echo '<script>alert("Username atau Password yang Anda masukan salah.");window.location.href="'.base_url('').'";</script>';
                }
            }
        }
    }

    public function proses_register()
    {
        $this->load->library('form_validation');
        $this->load->library('session');

        $this->form_validation->set_rules('name', 'Nama', 'required');
        $this->form_validation->set_rules('username', 'Username', 'required|min_length[5]|max_length[15]|is_unique[users.username]');
        $this->form_validation->set_rules('password', 'Password', 'required|trim');
        
        if ($this->form_validation->run() == FALSE) {
            $errors = $this->form_validation->error_array();
            $this->session->set_flashdata('errors', $errors);
            $this->session->set_flashdata('input', $this->input->post());
            redirect('Masuk/register');
        } else {
            $username = $this->input->post('username');
            $name = $this->input->post('name');
            $password = $this->input->post('password');
            $pass = password_hash($password, PASSWORD_DEFAULT);
            $data = [
                'username' => $username,
                'name' => $name,
                'password' => $pass
            ];
            $insert = $this->Auth_model->register("users", $data);
            if($insert){
                echo '<script>alert("Sukses! Anda berhasil melakukan register. Silahkan login untuk mengakses data.");window.location.href="'.base_url('Masuk/login').'";</script>';
            }
        }
    }

    public function logout()
    {
        $this->session->sess_destroy();
        redirect('');
       // echo '<script>alert("Sukses! Anda berhasil logout."); window.location.href="'.base_url('').'";
       // </script>';
    }
}
