<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Person extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
		$this->load->model('person_model','Person');
	}

	public function editIpPublic()
	{
		if ($this->session->userdata('valid') == FALSE && $this->session->userdata('id') == "") {
			redirect("Masuk");
		}		
		$this->load->helper('url');
		$a['page']			= "gantiIP";
		$this->load->view('template/beranda', $a);
	}

	public function cekkoneksi()
	{
		if ($this->session->userdata('valid') == FALSE && $this->session->userdata('id') == "") {
			redirect("Masuk");
		}		
		
		// $a['dataHT']		= $this->Model_ip->getHT();
		$a['page']			= "cekkoneksi";
		$this->load->view('template/beranda', $a);	
	}

	public function ajax_list()
	{
		$this->load->helper('url');

		$list = $this->Person->get_datatables();
		$data = array();
		$no = $_POST['start'];
		foreach ($list as $person) {
			$no++;
			$row = array();
			$row[] = $person->nama_pa;
			$row[] = '<span class="badge badge-info">'.$person->alamat_ip.'</span>';
			$row[] = $person->nama_ketua;
			$row[] = $person->notelp_ketua;
			$row[] = $person->hakim_tinggi_pengawas;
			$row[] = $person->notelp_hakim_tinggi_pengawas;
			//if($person->photo)
			//	$row[] = '<a href="'.base_url('upload/'.$person->photo).'" target="_blank"><img src="'.base_url('upload/'.$person->photo).'" class="img-responsive" /></a>';
			//else
			//	$row[] = '(No photo)';

			//add html for action
			$row[] = '<a class="btn btn-icon btn-sm icon-left btn-primary" href="javascript:void(0)" title="Edit" onclick="edit_person('."'".$person->id."'".')"><i class="far fa-edit"></i> Edit</a>
				  <a class="btn btn-icon btn-sm icon-left btn-warning" href="javascript:void(0)" title="Hapus" onclick="delete_person('."'".$person->id."'".')"><i class="fas fa-exclamation-triangle"></i> Delete</a>';
		
			$data[] = $row;
		}

		$output = array(
						"draw" => $_POST['draw'],
						"recordsTotal" => $this->Person->count_all(),
						"recordsFiltered" => $this->Person->count_filtered(),
						"data" => $data,
				);
		//output to json format
		echo json_encode($output);
	}

	public function ajax_edit($id)
	{
		$data = $this->Person->get_by_id($id);
		//$data->dob = ($data->dob == '0000-00-00') ? '' : $data->dob; // if 0000-00-00 set tu empty for datepicker compatibility
		echo json_encode($data);
	}

	public function ajax_add()
	{
		$this->_validate();
		
		$data = array(
				'nama_pa' => $this->input->post('nama_pa'),
				'alamat_ip' => $this->input->post('alamat_ip'),
				'nama_ketua' => $this->input->post('nama_ketua'),
				'notelp_ketua' => $this->input->post('notelp_ketua'),
				'hakim_tinggi_pengawas' => $this->input->post('hakim_tinggi_pengawas'),
				'notelp_hakim_tinggi_pengawas' => $this->input->post('notelp_hakim_tinggi_pengawas'),
			);

		//if(!empty($_FILES['photo']['name']))
		//{
		//	$upload = $this->_do_upload();
		//	$data['photo'] = $upload;
		//}

		$insert = $this->Person->save($data);

		echo json_encode(array("status" => TRUE));
	}

	public function ajax_update()
	{
		$this->_validate();
		$data = array(
				'nama_pa' => $this->input->post('nama_pa'),
				'alamat_ip' => $this->input->post('alamat_ip'),
				'nama_ketua' => $this->input->post('nama_ketua'),
				'notelp_ketua' => $this->input->post('notelp_ketua'),
				'hakim_tinggi_pengawas' => $this->input->post('hakim_tinggi_pengawas'),
				'notelp_hakim_tinggi_pengawas' => $this->input->post('notelp_hakim_tinggi_pengawas'),				
			);

		// if($this->input->post('remove_photo')) // if remove photo checked
		// {
		// 	if(file_exists('upload/'.$this->input->post('remove_photo')) && $this->input->post('remove_photo'))
		// 		unlink('upload/'.$this->input->post('remove_photo'));
		// 	$data['photo'] = '';
		// }

		// if(!empty($_FILES['photo']['name']))
		// {
		// 	$upload = $this->_do_upload();
			
		// 	//delete file
		// 	$person = $this->Person->get_by_id($this->input->post('id'));
		// 	if(file_exists('upload/'.$person->photo) && $person->photo)
		// 		unlink('upload/'.$person->photo);

		// 	$data['photo'] = $upload;
		// }

		$this->Person->update(array('id' => $this->input->post('id')), $data);
		echo json_encode(array("status" => TRUE));
	}

	public function ajax_delete($id)
	{
		//delete file
		$person = $this->Person->get_by_id($id);
		if(file_exists('upload/'.$person->photo) && $person->photo)
			unlink('upload/'.$person->photo);
		
		$this->Person->delete_by_id($id);
		echo json_encode(array("status" => TRUE));
	}

	private function _do_upload()
	{
		$config['upload_path']          = 'upload/';
        $config['allowed_types']        = 'gif|jpg|png|PNG';
        $config['max_size']             = 10000; //set max size allowed in Kilobyte
        $config['max_width']            = 10000; // set max width image allowed
        $config['max_height']           = 10000; // set max height allowed
        $config['file_name']            = round(microtime(true) * 1000); //just milisecond timestamp fot unique name

        $this->load->library('upload', $config);

        if(!$this->upload->do_upload('photo')) //upload and validate
        {
            $data['inputerror'][] = 'photo';
			$data['error_string'][] = 'Upload error: '.$this->upload->display_errors('',''); //show ajax error
			$data['status'] = FALSE;
			echo json_encode($data);
			exit();
		}
		return $this->upload->data('file_name');
	}

	private function _validate()
	{
		$data = array();
		$data['error_string'] = array();
		$data['inputerror'] = array();
		$data['status'] = TRUE;

		if($this->input->post('nama_pa') == '')
		{
			$data['inputerror'][] = 'nama_pa';
			$data['error_string'][] = 'Masukan Nama Pengadilan Agama';
			$data['status'] = FALSE;
		}

		if($this->input->post('alamat_ip') == '')
		{
			$data['inputerror'][] = 'alamat_ip';
			$data['error_string'][] = 'Masukan Alamat IP Public';
			$data['status'] = FALSE;
		}

		

		if($data['status'] === FALSE)
		{
			echo json_encode($data);
			exit();
		}
	}

}