<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class User extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
		$this->load->model('Model_user','User');
	}

	public function index()
	{
		$this->load->helper('url');
		$this->load->view('User');
	}

	public function ajax_list()
	{
		$this->load->helper('url');

		$list = $this->User->get_datatables();
		$data = array();
		$no = $_POST['start'];
		foreach ($list as $person) {
			$no++;
			$row = array();
			$row[] = $person->name;
			$row[] = $person->username;
			// $row[] = $person->password;
			$row[] = $person->hak_akses;

			//add html for action
			$row[] = '<a class="btn btn-icon btn-sm icon-left btn-primary" href="javascript:void(0)" title="Edit" onclick="edit_person('."'".$person->id."'".')"><i class="far fa-edit"></i> Edit</a>';
		
			$data[] = $row;
		}

		$output = array(
						"draw" => $_POST['draw'],
						"recordsTotal" => $this->User->count_all(),
						"recordsFiltered" => $this->User->count_filtered(),
						"data" => $data,
				);
		//output to json format
		echo json_encode($output);
	}

	public function ajax_edit($id)
	{
		$data = $this->User->get_by_id($id);
		// $data->dob = ($data->dob == '0000-00-00') ? '' : $data->dob; // if 0000-00-00 set tu empty for datepicker compatibility
		echo json_encode($data);
	}

	public function ajax_add()
	{
		$this->_validate();
		$hakcuti=12;
		$data = array(
				'nip' => $this->input->post('nip'),
				'nama' => $this->input->post('nama'),
				'pangkat' => $this->input->post('pangkat'),
				'jab' => $this->input->post('jab'),
				'telp' => $this->input->post('telp'),
				'unit_kerja' => $this->input->post('unit_kerja'),
				'hak_cuti_tahunan' => $this->input->post('hak_cuti_tahunan'),
				'update_awal_thn' => $this->input->post('update_awal_tahun'),
			);

		if(!empty($_FILES['photo']['name']))
		{
			$upload = $this->_do_upload();
			$data['foto'] = $upload;
		}

		$insert = $this->User->save($data);

		echo json_encode(array("status" => TRUE));
	}

	public function ajax_update()
	{
		$this->load->library('form_validation');
		$this->_validate();

		$password =  $this->input->post('password');
		$pass 	  = password_hash($password,PASSWORD_DEFAULT);
		$data = array(
				'password' => $pass,
				'hak_akses' => $this->input->post('hak_akses'),
				// 'password' => $this->input->post('password'),
			);


		$this->User->update(array('id' => $this->input->post('id')), $data);
		echo json_encode(array("status" => TRUE));
	}

	public function ajax_delete($id)
	{
		//delete file
		$person = $this->User->get_by_id($id);
		if(file_exists('upload/'.$person->foto) && $person->foto)
			unlink('upload/'.$person->foto);
		
		$this->User->delete_by_id($id);
		echo json_encode(array("status" => TRUE));
	}

	private function _do_upload()
	{
		$config['upload_path']          = 'upload/';
        $config['allowed_types']        = 'gif|jpg|png|PNG';
        $config['max_size']             = 1000; //set max size allowed in Kilobyte
        $config['max_width']            = 1000; // set max width image allowed
        $config['max_height']           = 1000; // set max height allowed
        $config['file_name']            = round(microtime(true) * 1000); //just milisecond timestamp fot unique name

        $this->load->library('upload', $config);

        if(!$this->upload->do_upload('photo')) //upload and validate
        {
            $data['inputerror'][] = 'photo';
			$data['error_string'][] = 'Upload error: '.$this->upload->display_errors('',''); //show ajax error
			$data['status'] = FALSE;
			echo json_encode($data);
			exit();
		}
		return $this->upload->data('file_name');
	}

	private function _validate()
	{
		$data = array();
		$data['error_string'] = array();
		$data['inputerror'] = array();
		$data['status'] = TRUE;


		if($this->input->post('password') == '')
		{
			$data['inputerror'][] = 'password';
			$data['error_string'][] = 'Password is required';
			$data['status'] = FALSE;
		}

		if($this->input->post('password1') == '')
		{
			$data['inputerror'][] = 'password1';
			$data['error_string'][] = 'Verify Password is required';
			$data['status'] = FALSE;
		}

		if($this->input->post('password') != $this->input->post('password1'))
		{
			$data['inputerror'][] = 'password1';
			$data['error_string'][] = 'Password tidak sama';
			$data['status'] = FALSE;
		}

		if($this->input->post('hak_akses') == '')
		{
			$data['inputerror'][] = 'hak_akses';
			$data['error_string'][] = 'Hak Akses is required';
			$data['status'] = FALSE;
		}

		if($data['status'] === FALSE)
		{
			echo json_encode($data);
			exit();
		}
	}

}
